diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/theme.php ./wordpress-3.3/wp-includes/theme.php
*** ./wordpress-3.2.1/wp-includes/theme.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/theme.php	2011-11-14 17:56:18.000000000 -0600
***************
*** 469,475 ****
   *
   * @since 2.9.0
   *
!  * @return array|string An arry of theme roots keyed by template/stylesheet or a single theme root if all themes have the same root.
   */
  function get_theme_roots() {
  	global $wp_theme_directories;
--- 469,475 ----
   *
   * @since 2.9.0
   *
!  * @return array|string An array of theme roots keyed by template/stylesheet or a single theme root if all themes have the same root.
   */
  function get_theme_roots() {
  	global $wp_theme_directories;
***************
*** 496,502 ****
  function get_theme($theme) {
  	$themes = get_themes();
  
! 	if ( array_key_exists($theme, $themes) )
  		return $themes[$theme];
  
  	return null;
--- 496,502 ----
  function get_theme($theme) {
  	$themes = get_themes();
  
! 	if ( is_array( $themes ) && array_key_exists( $theme, $themes ) )
  		return $themes[$theme];
  
  	return null;
***************
*** 518,529 ****
  		return $theme;
  
  	$themes = get_themes();
! 	$theme_names = array_keys($themes);
! 	$current_template = get_option('template');
! 	$current_stylesheet = get_option('stylesheet');
! 	$current_theme = 'Twenty Ten';
  
  	if ( $themes ) {
  		foreach ( (array) $theme_names as $theme_name ) {
  			if ( $themes[$theme_name]['Stylesheet'] == $current_stylesheet &&
  					$themes[$theme_name]['Template'] == $current_template ) {
--- 518,530 ----
  		return $theme;
  
  	$themes = get_themes();
! 	$current_theme = 'Twenty Eleven';
  
  	if ( $themes ) {
+ 		$theme_names = array_keys( $themes );
+ 		$current_template = get_option( 'template' );
+ 		$current_stylesheet = get_option( 'stylesheet' );
+ 
  		foreach ( (array) $theme_names as $theme_name ) {
  			if ( $themes[$theme_name]['Stylesheet'] == $current_stylesheet &&
  					$themes[$theme_name]['Template'] == $current_template ) {
***************
*** 1246,1252 ****
   * @param string $stylesheet Stylesheet name.
   */
  function switch_theme($template, $stylesheet) {
! 	global $wp_theme_directories;
  
  	update_option('template', $template);
  	update_option('stylesheet', $stylesheet);
--- 1247,1258 ----
   * @param string $stylesheet Stylesheet name.
   */
  function switch_theme($template, $stylesheet) {
! 	global $wp_theme_directories, $sidebars_widgets;
! 
! 	if ( is_array( $sidebars_widgets ) )
! 		set_theme_mod( 'sidebars_widgets', array( 'time' => time(), 'data' => $sidebars_widgets ) );
! 
! 	$old_theme = get_current_theme();
  
  	update_option('template', $template);
  	update_option('stylesheet', $stylesheet);
***************
*** 1260,1266 ****
  		$default_theme_mods = (array) get_option( "mods_$theme" );
  		add_option( "theme_mods_$stylesheet", $default_theme_mods );
  	}
! 	do_action('switch_theme', $theme);
  }
  
  /**
--- 1269,1277 ----
  		$default_theme_mods = (array) get_option( "mods_$theme" );
  		add_option( "theme_mods_$stylesheet", $default_theme_mods );
  	}
! 
! 	update_option( 'theme_switched', $old_theme );
! 	do_action( 'switch_theme', $theme );
  }
  
  /**
***************
*** 1718,1724 ****
  	if ( ! is_admin() )
  		return;
  	require_once( ABSPATH . 'wp-admin/custom-background.php' );
! 	$GLOBALS['custom_background'] =& new Custom_Background( $admin_header_callback, $admin_image_div_callback );
  	add_action( 'admin_menu', array( &$GLOBALS['custom_background'], 'init' ) );
  }
  
--- 1729,1735 ----
  	if ( ! is_admin() )
  		return;
  	require_once( ABSPATH . 'wp-admin/custom-background.php' );
! 	$GLOBALS['custom_background'] = new Custom_Background( $admin_header_callback, $admin_image_div_callback );
  	add_action( 'admin_menu', array( &$GLOBALS['custom_background'], 'init' ) );
  }
  
***************
*** 1783,1789 ****
  	}
  ?>
  <style type="text/css">
! body { <?php echo trim( $style ); ?> }
  </style>
  <?php
  }
--- 1794,1800 ----
  	}
  ?>
  <style type="text/css">
! body.custom-background { <?php echo trim( $style ); ?> }
  </style>
  <?php
  }
***************
*** 1936,1945 ****
  			if ( true === $_wp_theme_features[$feature] )  // Registered for all types
  				return true;
  			$content_type = $args[0];
! 			if ( in_array($content_type, $_wp_theme_features[$feature][0]) )
! 				return true;
! 			else
! 				return false;
  			break;
  	}
  
--- 1947,1960 ----
  			if ( true === $_wp_theme_features[$feature] )  // Registered for all types
  				return true;
  			$content_type = $args[0];
! 			return in_array( $content_type, $_wp_theme_features[$feature][0] );
! 			break;
! 
! 		case 'post-formats':
! 			// specific post formats can be registered by passing an array of types to
! 			// add_theme_support()
! 			$post_format = $args[0];
! 			return in_array( $post_format, $_wp_theme_features[$feature][0] );
  			break;
  	}
  
***************
*** 1982,1985 ****
  
  add_action( 'delete_attachment', '_delete_attachment_theme_mod' );
  
! ?>
--- 1997,2010 ----
  
  add_action( 'delete_attachment', '_delete_attachment_theme_mod' );
  
! /**
!  * Checks if a theme has been changed and runs 'after_switch_theme' hook on the next WP load
!  *
!  * @since 3.3
!  */
! function check_theme_switched() {
! 	if ( false !== ( $old_theme = get_option( 'theme_switched' ) ) && !empty( $old_theme ) ) {
! 		do_action( 'after_switch_theme', $old_theme );
! 		update_option( 'theme_switched', false );
! 	}
! }
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/update.php ./wordpress-3.3/wp-includes/update.php
*** ./wordpress-3.2.1/wp-includes/update.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/update.php	2011-11-16 01:23:15.000000000 -0600
***************
*** 57,64 ****
  		$wp_install = home_url( '/' );
  	}
  
! 	$local_package = isset( $wp_local_package )? $wp_local_package : '';
! 	$url = "http://api.wordpress.org/core/version-check/1.6/?version=$wp_version&php=$php_version&locale=$locale&mysql=$mysql_version&local_package=$local_package&blogs=$num_blogs&users={$user_count['total_users']}&multisite_enabled=$multisite_enabled";
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3 ),
--- 57,74 ----
  		$wp_install = home_url( '/' );
  	}
  
! 	$query = array(
! 		'version'           => $wp_version,
! 		'php'               => $php_version,
! 		'locale'            => $locale,
! 		'mysql'             => $mysql_version,
! 		'local_package'     => isset( $wp_local_package ) ? $wp_local_package : '',
! 		'blogs'             => $num_blogs,
! 		'users'             => $user_count['total_users'],
! 		'multisite_enabled' => $multisite_enabled
! 	);
! 
! 	$url = 'http://api.wordpress.org/core/version-check/1.6/?' . http_build_query( $query, null, '&' );
  
  	$options = array(
  		'timeout' => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 3 ),
***************
*** 133,139 ****
  
  	$new_option = new stdClass;
  	$new_option->last_checked = time();
! 	$timeout = 'load-plugins.php' == current_filter() ? 3600 : 43200; //Check for updated every 60 minutes if hitting the themes page, Else, check every 12 hours
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
  
  	$plugin_changed = false;
--- 143,150 ----
  
  	$new_option = new stdClass;
  	$new_option->last_checked = time();
! 	// Check for updated every 60 minutes if hitting update pages; else, check every 12 hours.
! 	$timeout = in_array( current_filter(), array( 'load-plugins.php', 'load-update.php', 'load-update-core.php' ) ) ? 3600 : 43200;
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
  
  	$plugin_changed = false;
***************
*** 211,217 ****
  	if ( ! is_object($last_update) )
  		$last_update = new stdClass;
  
! 	$timeout = 'load-themes.php' == current_filter() ? 3600 : 43200; //Check for updated every 60 minutes if hitting the themes page, Else, check every 12 hours
  	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time( ) - $last_update->last_checked );
  
  	$themes = array();
--- 222,229 ----
  	if ( ! is_object($last_update) )
  		$last_update = new stdClass;
  
! 	// Check for updated every 60 minutes if hitting update pages; else, check every 12 hours.
! 	$timeout = in_array( current_filter(), array( 'load-themes.php', 'load-update.php', 'load-update-core.php' ) ) ? 3600 : 43200;
  	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time( ) - $last_update->last_checked );
  
  	$themes = array();
***************
*** 280,285 ****
--- 292,339 ----
  	set_site_transient( 'update_themes', $new_update );
  }
  
+ /*
+  * Collect counts and UI strings for available updates
+  *
+  * @since 3.3.0
+  *
+  * @return array
+  */
+ function wp_get_update_data() {
+ 	$counts = array( 'plugins' => 0, 'themes' => 0, 'wordpress' => 0 );
+ 
+ 	if ( current_user_can( 'update_plugins' ) ) {
+ 		$update_plugins = get_site_transient( 'update_plugins' );
+ 		if ( ! empty( $update_plugins->response ) )
+ 			$counts['plugins'] = count( $update_plugins->response );
+ 	}
+ 
+ 	if ( current_user_can( 'update_themes' ) ) {
+ 		$update_themes = get_site_transient( 'update_themes' );
+ 		if ( ! empty( $update_themes->response ) )
+ 			$counts['themes'] = count( $update_themes->response );
+ 	}
+ 
+ 	if ( function_exists( 'get_core_updates' ) && current_user_can( 'update_core' ) ) {
+ 		$update_wordpress = get_core_updates( array('dismissed' => false) );
+ 		if ( ! empty( $update_wordpress ) && ! in_array( $update_wordpress[0]->response, array('development', 'latest') ) && current_user_can('update_core') )
+ 			$counts['wordpress'] = 1;
+ 	}
+ 
+ 	$counts['total'] = $counts['plugins'] + $counts['themes'] + $counts['wordpress'];
+ 	$update_title = array();
+ 	if ( $counts['wordpress'] )
+ 		$update_title[] = sprintf(__('%d WordPress Update'), $counts['wordpress']);
+ 	if ( $counts['plugins'] )
+ 		$update_title[] = sprintf(_n('%d Plugin Update', '%d Plugin Updates', $counts['plugins']), $counts['plugins']);
+ 	if ( $counts['themes'] )
+ 		$update_title[] = sprintf(_n('%d Theme Update', '%d Theme Updates', $counts['themes']), $counts['themes']);
+ 
+ 	$update_title = ! empty( $update_title ) ? esc_attr( implode( ', ', $update_title ) ) : '';
+ 
+ 	return array( 'counts' => $counts, 'title' => $update_title );
+ }
+ 
  function _maybe_update_core() {
  	include ABSPATH . WPINC . '/version.php'; // include an unmodified $wp_version
  
***************
*** 343,349 ****
  		wp_schedule_event(time(), 'twicedaily', 'wp_update_themes');
  }
  
! if ( ! is_main_site() )
  	return;
  
  add_action( 'admin_init', '_maybe_update_core' );
--- 397,403 ----
  		wp_schedule_event(time(), 'twicedaily', 'wp_update_themes');
  }
  
! if ( ! is_main_site() && ! is_network_admin() )
  	return;
  
  add_action( 'admin_init', '_maybe_update_core' );
